##### create clock #####
#derive_pll_clocks -create_base_clocks
create_clock -name {clk} -period 20.000 -waveform { 0.000 10.000 } [get_ports {clk}]

create_generated_clock -name {avclk} -source [get_pins {u0|altpll|sd1|pll7|inclk[0]}] -duty_cycle 50/1 -multiply_by 8 -divide_by 5 -phase 45/4 -master_clock {clk} [get_pins {u0|altpll|sd1|pll7|clk[0]}] 
create_generated_clock -name {sdclk} -source [get_pins {u0|altpll|sd1|pll7|inclk[0]}] -duty_cycle 50/1 -multiply_by 8 -divide_by 5 -phase 45/4 -master_clock {clk} [get_pins {u0|altpll|sd1|pll7|clk[1]}] 
create_generated_clock -name {flash_se_neg_reg} -source [get_pins {u0|altpll|sd1|pll7|clk[0]}] -duty_cycle 50.000 -divide_by 1 [get_keepers {keim08core:u0|altera_onchip_flash:onchip_flash|altera_onchip_flash_avmm_data_controller:avmm_data_controller|flash_se_neg_reg}] 

set_clock_groups -asynchronous -group {avclk} -group {sdclk}
derive_clock_uncertainty

##### input delay #####
set_input_delay -clock { sdclk } 2.7 [get_ports {mem_dq[*]}]
set_input_delay -clock { altera_reserved_tck } -min 9  [get_ports {altera_reserved_tms}]
set_input_delay -clock { altera_reserved_tck } -max 11 [get_ports {altera_reserved_tms}]
set_input_delay -clock { altera_reserved_tck } -min 9  [get_ports {altera_reserved_tdi}]
set_input_delay -clock { altera_reserved_tck } -max 11 [get_ports {altera_reserved_tdi}]

##### output delay #####
set_output_delay -clock { sdclk } -min -1.0 [get_ports {mem_a[*] mem_dq[*] sdram_ba[*] sdram_dqm[*] sdram_cs_n sdram_ras_n sdram_cas_n sdram_we_n sdram_cke}]
set_output_delay -clock { sdclk } -max 1.5  [get_ports {mem_a[*] mem_dq[*] sdram_ba[*] sdram_dqm[*] sdram_cs_n sdram_ras_n sdram_cas_n sdram_we_n sdram_cke}]
set_output_delay -clock { sdclk } -min -1.0 [get_ports {flash_ce_n flash_we_n flash_oe_n}]
set_output_delay -clock { sdclk } -max 1.5  [get_ports {flash_ce_n flash_we_n flash_oe_n}]
set_output_delay -clock { altera_reserved_tck } -max 15 [get_ports {altera_reserved_tdo}]
set_output_delay -clock { altera_reserved_tck } -min 6 [get_ports {altera_reserved_tdo}]

##### false path #####
set_false_path -from [get_ports {reset_n}]
set_false_path -from [get_ports {pa_pin[*]}]
set_false_path -from [get_ports {pb_pin[*]}]
set_false_path -from [get_ports {pc_pin[*]}]
set_false_path -from [get_ports {pd_pin[*]}]
set_false_path -from [get_ports {pe_pin[*]}]
set_false_path -to [get_ports {pa_pin[*]}]
set_false_path -to [get_ports {pb_pin[*]}]
set_false_path -to [get_ports {pc_pin[*]}]
set_false_path -to [get_ports {pd_pin[*]}]
set_false_path -to [get_ports {pe_pin[*]}]
set_false_path -to [get_ports {flash_rst_n}]
set_false_path -to [get_ports {sdram_clk}]
