// (C) 2001-2016 Altera Corporation. All rights reserved.
// Your use of Altera Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License Subscription 
// Agreement, Altera MegaCore Function License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Altera and sold by 
// Altera or its authorized distributors.  Please refer to the applicable 
// agreement for further details.



  
`timescale 1 ns / 1 ns

			 
module keim08core_tristate_conduit_pin_sharer_0_pin_sharer (
 // ** Clock and Reset Connections
    input  logic clk
   ,input  logic reset

 // ** Arbiter Connections

 // *** Arbiter Grant Interface
   ,output logic ack
   ,input  logic [ 2 - 1 : 0 ] next_grant

// *** Arbiter Request Interface

    ,output logic arb_flash_tcm 
    ,output logic arb_sdram_tcm 
		
		     // ** Avalon TC Slave Interfaces




  // Slave Interface tcs1

    ,input  logic tcs1_request 
    ,output logic tcs1_grant   

  //flash.tcm signals
    ,input  logic[ 21 :0 ] tcs1_tcm_address_out
    ,input  logic[ 0 :0 ] tcs1_tcm_read_n_out
    ,input  logic[ 0 :0 ] tcs1_tcm_reset_n_out
    ,input  logic[ 0 :0 ] tcs1_tcm_write_n_out
    ,output logic[ 15 :0 ]  tcs1_tcm_data_in
    ,input  logic[ 15 :0 ]  tcs1_tcm_data_out
    ,input  logic tcs1_tcm_data_outen
    ,input  logic[ 0 :0 ] tcs1_tcm_chipselect_n_out



  // Slave Interface tcs0

    ,input  logic tcs0_request 
    ,output logic tcs0_grant   

  //sdram.tcm signals
    ,input  logic[ 0 :0 ] tcs0_sdram_ras_n
    ,input  logic[ 0 :0 ] tcs0_sdram_we_n
    ,output logic[ 15 :0 ]  tcs0_sdram_dq_in
    ,input  logic[ 15 :0 ]  tcs0_sdram_dq_out
    ,input  logic tcs0_sdram_dq_oe
    ,input  logic[ 0 :0 ] tcs0_sdram_cs_n
    ,input  logic[ 11 :0 ] tcs0_sdram_addr
    ,input  logic[ 1 :0 ] tcs0_sdram_ba
    ,input  logic[ 1 :0 ] tcs0_sdram_dqm
    ,input  logic[ 0 :0 ] tcs0_sdram_cas_n
    ,input  logic[ 0 :0 ] tcs0_sdram_cke
		     
		     // ** Avalon TC Master Interface
    ,output logic request
    ,input  logic grant

		     // *** Passthrough Signals
		     
    ,output  logic[ 0 :0 ] flash_tcm_read_n_out
    ,output  logic[ 0 :0 ] flash_tcm_reset_n_out
    ,output  logic[ 0 :0 ] flash_tcm_write_n_out
    ,output  logic[ 0 :0 ] flash_tcm_chipselect_n_out
    ,output  logic[ 0 :0 ] sdram_sdram_ras_n
    ,output  logic[ 0 :0 ] sdram_sdram_we_n
    ,output  logic[ 0 :0 ] sdram_sdram_cs_n
    ,output  logic[ 1 :0 ] sdram_sdram_ba
    ,output  logic[ 1 :0 ] sdram_sdram_dqm
    ,output  logic[ 0 :0 ] sdram_sdram_cas_n
    ,output  logic[ 0 :0 ] sdram_sdram_cke
		     
                     // *** Shared Signals
		      	     
    ,input   logic[ 15  :0 ]  dq_in
    ,output  logic[ 15  :0 ]  dq
    ,output  logic dq_outen
    ,output  logic[ 21 :0 ] addr

		     );

   function [2-1:0] getIndex;
      
      input [2-1:0] select;
      
      getIndex = 'h0;
      
      for(int i=0; i < 2; i = i + 1) begin
	 if( select[i] == 1'b1 )
           getIndex = i;
      end
      
   endfunction // getIndex

   logic[ 2 - 1 : 0 ] selected_grant;


   // Request Assignments

    assign arb_flash_tcm = tcs1_request;
    assign arb_sdram_tcm = tcs0_request;
   
   logic [ 2 - 1 : 0 ] concated_incoming_requests;
   
   
   assign 			      concated_incoming_requests = {						    
         tcs1_request 
        ,tcs0_request 
				};
   
				       
   assign 			      request = | concated_incoming_requests;
  assign        tcs0_grant = selected_grant[0];
  assign        tcs1_grant = selected_grant[1];

   
    // Perform Grant Selection						  
   always@(posedge clk, posedge reset) begin
     if(reset) begin
	selected_grant<=0;
	ack <= 0;
     end 
     else begin
       if(grant && (concated_incoming_requests[getIndex(selected_grant)] == 0 || selected_grant == 0 )) begin
	  if(~request)
	    selected_grant <= '0;
	  else
	    selected_grant <= next_grant;
	  
          ack<=1;
       end
       else begin
         ack<=0;
         selected_grant <= selected_grant;
       end
     end
   end // always@ (posedge clk, posedge reset)

// Passthrough Signals

    assign flash_tcm_read_n_out = tcs1_tcm_read_n_out;
    assign flash_tcm_reset_n_out = tcs1_tcm_reset_n_out;
    assign flash_tcm_write_n_out = tcs1_tcm_write_n_out;
    assign flash_tcm_chipselect_n_out = tcs1_tcm_chipselect_n_out;
    assign sdram_sdram_ras_n = tcs0_sdram_ras_n;
    assign sdram_sdram_we_n = tcs0_sdram_we_n;
    assign sdram_sdram_cs_n = tcs0_sdram_cs_n;
    assign sdram_sdram_ba = tcs0_sdram_ba;
    assign sdram_sdram_dqm = tcs0_sdram_dqm;
    assign sdram_sdram_cas_n = tcs0_sdram_cas_n;
    assign sdram_sdram_cke = tcs0_sdram_cke;
  
// Renamed Signals
  
// Shared Signals
  assign tcs0_sdram_dq_in = dq_in[15:0]; 
  assign tcs1_tcm_data_in = dq_in[15:0]; 
  keim08core_tristate_conduit_pin_sharer_0_pin_sharer_multiplexor_2 #(.WIDTH(1) )
    dq_outen_mux (
                              {
                                tcs1_grant
                               ,tcs0_grant
                              }
                              ,tcs1_tcm_data_outen
                              ,tcs0_sdram_dq_oe
                              , dq_outen
                             );
  keim08core_tristate_conduit_pin_sharer_0_pin_sharer_multiplexor_2 #(.WIDTH(16) )
    dq_mux (
                              {
                                tcs1_grant
                               ,tcs0_grant
                              }
                              ,tcs1_tcm_data_out
                              ,tcs0_sdram_dq_out
                              , dq
                             );
  keim08core_tristate_conduit_pin_sharer_0_pin_sharer_multiplexor_2 #(.WIDTH(22) )
    addr_mux (
                              {
                                tcs1_grant
                               ,tcs0_grant
                              }
                              ,tcs1_tcm_address_out
                              ,{10'h0,tcs0_sdram_addr}
                              , addr
                             );
  
endmodule   
					    

  
module keim08core_tristate_conduit_pin_sharer_0_pin_sharer_multiplexor_2
  #( parameter WIDTH      = 8
    ) (
    input logic  [ 2 -1 : 0]                       SelectVector,
    input logic  [ WIDTH - 1 : 0 ]                Input_1,
    input logic  [ WIDTH - 1 : 0 ]                Input_0,
    output logic [ WIDTH - 1 : 0 ]                OutputSignal
       );


function [2-1:0] getIndex;
      
    input [2-1:0] select;
   
    getIndex = 'h0;
    
    for(int i=0; i < 2; i = i + 1) begin
      if( select[i] == 1'b1 )
        getIndex = i;
    end
			      				
endfunction
								 
   always @* begin
     case(getIndex(SelectVector))
       default: OutputSignal = Input_0;
       0 : OutputSignal = Input_0;									   
       1 : OutputSignal = Input_1;									   
     endcase
   end
   
endmodule


